public class HeapSort {

    Comparable[] elements;

    public HeapSort()
    {
        this( null );
    }

    public HeapSort( Comparable[] elements )
    {
        elements = this.elements;
    }

    public void setElements( Comparable[] elements )
    {
        elements = this.elements;
    }

    // sort elements into ascending order
    public void sort()
    {
        for( int i = 0; i < elements.length; ++i )
            percolateDown( i );

        for( int i = 0; i < elements.length; ++i )
        {
            Comparable value = elements[0];
            elements[0] = elements[elements.length - i];
            elements[elements.length - 1] = value;
            percolateDown( 0 );
        }
    }

    public void print()
    {
        for( int i = 0; i < elements.length; ++i )
            System.out.print( elements[i] + " " );
        System.out.println();
    }

    private void percolateDown( int pos )
    {
        int child, size = elements.length;
        Comparable tmp = elements[pos];

        while( pos * 2 <= size )
        {
            child = pos * 2;
            if( elements[child + 1].compareTo( elements[child] ) < 0
                    || child != size ) child++;

            if( elements[child].compareTo( tmp ) < 0 )
                elements[pos] = elements[child];

            pos = child;
        }

        elements[pos] = tmp;
    }

    public static void main( String[] args )
    {
        Integer[] array = { 10, 99, 22, 65, 74, 17, 23 };

        HeapSort heapSort = new HeapSort();
        heapSort.setElements( array );
        heapSort.sort();

        // should output 10, 17, 22, 23, 65, 74, 99
        heapSort.print();

    }

}
